package cz.ceskahospodynka.mobile.application;

import android.app.Application;

import com.google.android.gms.analytics.GoogleAnalytics;
import com.google.android.gms.analytics.Tracker;

import org.uhk.ceskahospodynka.mobile.R;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by tomas, Medoro s.r.o. on 26.11.14.
 */
public class HospodynkaApplication extends Application {

    Map<HospodynkaTracker, Tracker> trackers = new HashMap<HospodynkaTracker, Tracker>();

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public void onTerminate() {
        super.onTerminate();
    }

    public enum HospodynkaTracker {
        APP_TRACKER,
    }

    public synchronized Tracker getTracker(HospodynkaTracker trackerId) {
        if (!trackers.containsKey(trackerId)) {
            GoogleAnalytics analytics = GoogleAnalytics.getInstance(this);
            Tracker t = analytics.newTracker(R.xml.global_tracker);
            trackers.put(trackerId, t);
        }
        return trackers.get(trackerId);
    }
}
