package cz.ceskahospodynka.mobile.core;

import android.content.Context;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.util.Base64;
import android.util.Log;

import java.security.MessageDigest;

/**
 * Created with IntelliJ IDEA.
 * User: tomas
 * Date: 8.12.13
 * Time: 17:00
 * To change this template use File | Settings | File Templates.
 */
public class Settings {

    public static final String WEB = "http://www.ceskahospodynka.cz";
    public static final String WEB_RECIPE = WEB + "/recept.jsp?id=?s";

    public static final String API_VERSION = "version1";

    public static final String SERVER = "http://www.ceskahospodynka.cz/hospodynka-api";
    //public static final String SERVER = "http://lab.hkfree.org/hospodynka-api";
    public static final String PARAM_API = "api";

    public static final String API_ARTICLES = SERVER + "/article/get";
    public static final String API_ARTICLE = SERVER + "/article/get-article";
    public static final String API_ARTICLE_PARAM_ID = "id";

    public static final String API_CATEGORIES = SERVER + "/categories/get";
    public static final String API_CATEGORIES_HASH = SERVER + "/categories/hash";

    public static final String API_LINK = SERVER + "/link/get";

    public static final String API_MENU = SERVER + "/menu/get";

    public static final String API_OPINIONS_RECIPE = SERVER + "/opinion/get";
    public static final String API_OPINIONS_RECIPE_PARAM_ID = "id";
    public static final String API_OPINIONS_LATEST = SERVER + "/opinion/latest";
    public static final String API_OPINIONS_SAVE = SERVER + "/opinion/save";
    public static final String API_OPINIONS_SAVE_OPINION = "opinion";
    public static final String API_OPINIONS_SAVE_SIGNATURE = "signature";
    public static final String API_OPINIONS_SAVE_RECIPE = "recipe";

    public static final String API_RECIPES = SERVER + "/recipes/get";
    public static final String API_RECIPES_PARAM_CATEGORY = "category";
    public static final String API_RECIPES_PARAM_START = "start";
    public static final String API_RECIPES_PARAM_LIMIT = "limit";
    public static final String API_RECIPES_PARAM_ORDER = "order";

    public static final String API_RECIPES_SEARCH = SERVER + "/recipes/search";
    public static final String API_RECIPES_SEARCH_PARAM_STRING = "search";
    public static final String API_RECIPES_SEARCH_PARAM_START = "start";
    public static final String API_RECIPES_SEARCH_PARAM_LIMIT = "limit";

    public static final String API_TITLE = SERVER + "/title/get";

    public static final String API_RECIPE = SERVER + "/recipes/get-recipe";
    public static final String API_RECIPE_PARAM_ID = "id";

    public static final String API_RECIPES_NEWS = SERVER + "/recipes/news";

    public static final String API_RECIPES_TOPWATCH = SERVER + "/recipes/topwatch";

    public static final String API_RECIPES_BESTS = SERVER + "/recipes/bests";

    public static final String API_RECIPES_IMAGE = SERVER + "/recipes/image/api/%s/type/%s/id/%d";

    public static final String API_RECIPES_SAVE_FAVORITE = SERVER + "/recipes/save-favorite";
    public static final String API_RECIPES_SAVE_FAVORITE_PARAM_USER = "user";
    public static final String API_RECIPES_SAVE_FAVORITE_PARAM_ID = "id";
    public static final String API_RECIPES_SAVE_FAVORITE_PARAM_SAVE = "save";

    public static final String API_RECIPES_SAVE_POINT = SERVER + "/recipes/save-point";
    public static final String API_RECIPES_SAVE_POINT_PARAM_ID = "id";

    public static final String API_LOGIN = SERVER + "/user/login";
    public static final String API_LOGIN_PARAM_LOGIN = "user";
    public static final String API_LOGIN_PARAM_PASSWORD = "password";

    public static final String API_SYNC = SERVER + "/user/sync";
    public static final String API_SYNC_PARAM_USER = "user";
    public static final String API_SYNC_PARAM_PASSWORD = "password";
    public static final String API_SYNC_PARAM_FACEBOOK = "facebook";
    public static final String API_SYNC_PARAM_GOOGLE = "google";
    public static final String API_SYNC_PARAM_RECIPES = "recipes";

    public static final int RECIPES_API_STEP = 10;
    public static final int RECIPES_NEWS = 10;
    public static final int RECIPES_HOMEPAGE = 8;

    public static final int RECIPES_BESTS = 15;

    public static final String IMAGE_SMALL = "small";
    public static final String IMAGE_MEDIUM = "medium";
    public static final String IMAGE_ORIGINAL = "original";

    private void showHash(Context context) {
        Log.d("KeyHash:", "start");
        try {
            PackageInfo info = context.getPackageManager().getPackageInfo("cz.ceskahospodynka.mobile", PackageManager.GET_SIGNATURES);
            for (android.content.pm.Signature signature : info.signatures) {
                MessageDigest md = MessageDigest.getInstance("SHA");
                md.update(signature.toByteArray());
                Log.d("KeyHash:", Base64.encodeToString(md.digest(), Base64.DEFAULT));
            }
        } catch (Exception e) {
            Log.e("KeyHash", e.getMessage(), e);
        }
    }
}
