package cz.ceskahospodynka.mobile.core.database.hospodynka.handlers;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.BitmapFactory;

import cz.ceskahospodynka.mobile.core.database.core.RS;
import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.CategoryModel;

/**
 * Created with IntelliJ IDEA.
 * User: tomas
 * Date: 12.11.13
 * Time: 19:26
 * To change this template use File | Settings | File Templates.
 */
public class CategoryHandler extends DefaultHandler {

    public CategoryHandler() {
        super(new CategoryModel());
    }

    public int getCount(SQLiteDatabase db) {
        CategoryModel categoryModel = (CategoryModel) model;
        Cursor cursor = db.query(categoryModel.getTableName(), new String[]{"COUNT("+categoryModel.getCategoryNameColumn()+") AS count"}, null, null, null, null, null, null);
        try {
            if (cursor != null) {
                cursor.moveToFirst();
                return cursor.getInt(cursor.getColumnIndex("count"));
            }
            return 0;
        } finally {
            cursor.close();
        }
    }

    /**
     * @param db - writable database
     */
    public void fetch(SQLiteDatabase db, RS rs) {
        CategoryModel categoryModel = (CategoryModel) model;
        String selectQuery = "SELECT * FROM " + categoryModel.getTableName();
        Cursor cursor = db.rawQuery(selectQuery, null);
        try {
            if (cursor.moveToFirst()) {
                do {
                    CategoryModel model = new CategoryModel();
                    model.categoryName = cursor.getString(cursor.getColumnIndex(model.getCategoryNameColumn()));
                    model.categoryDescription = cursor.getString(cursor.getColumnIndex(model.getCategoryDescriptionColumn()));

                    byte[] bb = cursor.getBlob(cursor.getColumnIndex(model.getCategoryImageColumn()));
                    model.categoryImage = BitmapFactory.decodeByteArray(bb, 0, bb.length);

                    rs.fetch(model);
                } while (cursor.moveToNext());
            }
        } finally {
            cursor.close();
        }
    }
}
