package cz.ceskahospodynka.mobile.core.tasks;

import android.util.Log;

import org.apache.http.message.BasicNameValuePair;

import cz.ceskahospodynka.mobile.core.Settings;
import cz.ceskahospodynka.mobile.core.utils.SHA1;

/**
 * Created by tomas, Medoro s.r.o. on 17.6.15.
 */
public class LoginTask extends AndroidTask {

    private String login;
    private String password;

    public LoginTask(String login, String password) {
        this.login = login;
        this.password = password;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_LOGIN_PARAM_LOGIN, login));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_LOGIN_PARAM_PASSWORD, SHA1.generateSHA1(password)));


        Log.d("CH LOGIN", Settings.API_LOGIN);
        serverCommunication.post(Settings.API_LOGIN);
        String response = serverCommunication.getResponse();
        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
