package cz.ceskahospodynka.mobile.core.tasks;

import org.apache.http.message.BasicNameValuePair;

import cz.ceskahospodynka.mobile.core.Settings;

/**
 * Created by tomas, Medoro s.r.o. on 16.6.15.
 */
public class OpinionSaveTask extends AndroidTask {

    private String opinion;
    private String signature;
    private Integer recipeId;

    public OpinionSaveTask(String opinion, String signature, Integer recipeId) {
        this.opinion = opinion;
        this.signature = signature;
        this.recipeId = recipeId;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
            serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_OPINIONS_SAVE_OPINION, opinion));
            serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_OPINIONS_SAVE_SIGNATURE, signature));
            serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_OPINIONS_SAVE_RECIPE, recipeId.toString()));

            serverCommunication.post(Settings.API_OPINIONS_SAVE);
            String response = serverCommunication.getResponse();
            return serverCommunication.getGson().fromJson(response, outputType);
    }
}
