package cz.ceskahospodynka.mobile.core.tasks;

import org.apache.http.message.BasicNameValuePair;
import cz.ceskahospodynka.mobile.core.Settings;

/**
 * Created by tomas, Medoro s.r.o. on 18.4.15.
 */
public class OpinionsTask extends AndroidTask {

    private Integer recipeId;

    public OpinionsTask() {
        this(null);
    }

    public OpinionsTask(Integer recipeId) {
        this.recipeId = recipeId;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
        if(recipeId == null) {
            serverCommunication.post(Settings.API_OPINIONS_LATEST);
        } else {
            serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_OPINIONS_RECIPE_PARAM_ID, recipeId.toString()));
            serverCommunication.post(Settings.API_OPINIONS_RECIPE);
        }

        String response = serverCommunication.getResponse();
        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
