package cz.ceskahospodynka.mobile.core.tasks;

import org.apache.http.message.BasicNameValuePair;
import cz.ceskahospodynka.mobile.core.Settings;

/**
 * Created by tomas, Medoro s.r.o. on 18.4.15.
 */
public class RecipesTask extends AndroidTask {

    private String cateogry;
    private Integer start;
    private Integer limit;
    private String order;

    public RecipesTask(String cateogry, Integer start, Integer limit, String order) {
        this.cateogry = cateogry;
        this.start = start;
        this.limit = limit;
        this.order = order;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_PARAM_CATEGORY, cateogry));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_PARAM_START, start+""));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_PARAM_LIMIT, limit+""));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_PARAM_ORDER, order));
        serverCommunication.post(Settings.API_RECIPES);
        String response = serverCommunication.getResponse();
        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
