package cz.ceskahospodynka.mobile.core.tasks;

import org.apache.http.message.BasicNameValuePair;
import cz.ceskahospodynka.mobile.core.Settings;

/**
 * Created by tomas, Medoro s.r.o. on 19.4.15.
 */
public class SaveFavoriteTask extends AndroidTask {

    private String userId;
    private Integer recipeId;
    private boolean save;

    public SaveFavoriteTask(String userId, Integer recipeId, boolean save) {
        this.userId = userId;
        this.recipeId = recipeId;
        this.save = save;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SAVE_FAVORITE_PARAM_USER, userId));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SAVE_FAVORITE_PARAM_ID, recipeId.toString()));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SAVE_FAVORITE_PARAM_SAVE, save+""));
        serverCommunication.post(Settings.API_RECIPES_SAVE_FAVORITE);
        String response = serverCommunication.getResponse();
        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
