package cz.ceskahospodynka.mobile.core.tasks;

import android.util.Log;

import org.apache.http.message.BasicNameValuePair;
import cz.ceskahospodynka.mobile.core.Settings;

/**
 * Created by tomas, Medoro s.r.o. on 22.4.15.
 */
public class SearchTask extends AndroidTask {

    private String string;
    private Integer start;
    private Integer limit;

    public SearchTask(String string, Integer start, Integer limit) {
        this.string = string;
        this.start = start;
        this.limit = limit;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SEARCH_PARAM_STRING, string));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SEARCH_PARAM_START, start+""));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_RECIPES_SEARCH_PARAM_LIMIT, limit+""));
        serverCommunication.post(Settings.API_RECIPES_SEARCH);
        String response = serverCommunication.getResponse();

        Log.d("TEST", "text: " + string);
        Log.d("TEST", "start: " + start);
        Log.d("TEST", "limit: " + limit);

        Log.d("TEST", response);

        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
