package cz.ceskahospodynka.mobile.core.tasks;

import android.util.Log;

import org.apache.http.message.BasicNameValuePair;

import cz.ceskahospodynka.mobile.core.Settings;
import cz.ceskahospodynka.mobile.core.utils.SHA1;

/**
 * Created by tomas, Medoro s.r.o. on 18.6.15.
 */
public class SyncTask extends AndroidTask {

    private String facebookId;
    private String googleId;
    private String user;
    private String password;
    private String recipes;

    public SyncTask(String facebookId, String googleId, String user, String password, String recipes) {
        this.facebookId = facebookId;
        this.googleId = googleId;
        this.user = user;
        this.password = password;
        this.recipes = recipes;
    }

    @Override
    protected <T> T perform(Class<T> outputType) throws Exception {

        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_SYNC_PARAM_USER, user));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_SYNC_PARAM_PASSWORD, password));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_SYNC_PARAM_FACEBOOK, facebookId));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_SYNC_PARAM_GOOGLE, googleId));
        serverCommunication.getParams().add(new BasicNameValuePair(Settings.API_SYNC_PARAM_RECIPES, recipes));

        serverCommunication.post(Settings.API_SYNC);
        String response = serverCommunication.getResponse();
        Log.d("TEST", response);
        return serverCommunication.getGson().fromJson(response, outputType);
    }
}
