package cz.ceskahospodynka.mobile.core.utils;

import android.content.Context;
import android.graphics.Bitmap;
import android.os.Environment;
import android.util.Log;

import cz.ceskahospodynka.mobile.core.database.DatabaseInfo;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.URL;

/**
 * Created with IntelliJ IDEA.
 * User: tomas
 * Date: 13.11.13
 * Time: 17:27
 * To change this template use File | Settings | File Templates.
 */
public class IO {

    public static String readUrl(String urlString) throws IOException {
        BufferedReader reader = null;
        try {
            Log.d("URL", urlString);
            URL url = new URL(urlString);
            reader = new BufferedReader(new InputStreamReader(url.openStream()));
            StringBuffer buffer = new StringBuffer();
            int read;
            char[] chars = new char[1024];
            while ((read = reader.read(chars)) != -1)
                buffer.append(chars, 0, read);

            return buffer.toString();
        } finally {
            if (reader != null)
                reader.close();
        }
    }

    public static void copyDbToSd(Context context) {
        File dbFile = context.getDatabasePath((String) DatabaseInfo.DATABASE_NAME);

        try {
            InputStream realDb = new FileInputStream(dbFile);
            try {
                OutputStream copyDb = new FileOutputStream(Environment.getExternalStorageDirectory() + java.io.File.separator + "ceskahospodynka_cz.db");
                try {
                    byte[] buffer = new byte[1024];
                    int length;
                    while ((length = realDb.read(buffer)) > 0) {
                        copyDb.write(buffer, 0, length);
                    }
                    copyDb.flush();
                    Log.d("database copy", "database moved to SD cart");
                } finally {
                    copyDb.close();
                }
            } finally {
                realDb.close();
            }
        } catch (FileNotFoundException e) {
            Log.e("database copy", "Exception: ", e);
        } catch (IOException e) {
            Log.e("database copy", "Exception: ", e);
        }
    }

    public static byte[] getBitmapAsByteArray(Bitmap bitmap) {
        if(bitmap == null){
            return null;
        }

        ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
        bitmap.compress(Bitmap.CompressFormat.PNG, 0, outputStream);
        return outputStream.toByteArray();
    }
}
