package cz.ceskahospodynka.mobile.core.utils;

import android.widget.TextView;

import java.util.Timer;
import java.util.TimerTask;

/**
 * Created by tomas, Medoro s.r.o. on 12.11.14.
 */
public abstract class TextChangeAction extends SimpleDocumentListener {

    private Timer typingTimer = null;
    private final TextView view;
    private final long typingDelay;
    private boolean enabled = true;

    public TextChangeAction(final TextView view, final long typingDelay) {
        this.view = view;
        this.typingDelay = typingDelay;
        view.addTextChangedListener(this);
    }

    @Override
    protected void change() {
        if (!enabled) return;
        if (typingTimer != null){
            typingTimer.cancel();
        }
        typingTimer = new Timer();
        typingTimer.schedule(new TimerTask() {

            @Override
            public void run() {
                synchronized (TextChangeAction.this) {
                    TextChangeAction.this.changeAction(view.getText().toString());
                }
            }
        }, typingDelay);
    }

    protected abstract void changeAction(String text);

}
