package cz.ceskahospodynka.mobile.ui;

import android.os.Bundle;
import android.webkit.WebView;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Article;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.ArticleTask;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 22.4.14.
 */

@ContentView(R.layout.article_detail)
public class ArticleDetailActivity extends ProcessActivity {

    private static final String TAG = ArticleDetailActivity.class.getSimpleName();

    private Integer articleId;

    @InjectView(R.id.article_detail_header)
    private TextView header;

    @InjectView(R.id.webView1)
    private WebView webDetail;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Bundle bundle = getIntent().getExtras();
        articleId = bundle.getInt(ArticlesActivity.EXTRA_ARTICLE_ID);

        if(isOnline()) {
            loadArticle();
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    private void loadArticle() {

        new ArticleTask(articleId).task(Article.Item.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if (val != null && val instanceof Article.Item) {
                    Article.Item item = (Article.Item) val;

                    header.setText(item.getNadpis());
                    String strDetail = item.getFejeton();
                    strDetail = strDetail.replace("src=\"image", "width=\"100%\" src=\"http://www.ceskahospodynka.cz/image");
                    webDetail.loadData(strDetail, "text/html; charset=UTF-8", null);
                    setProcess(false);
                }
            }
        });
    }
}
