package cz.ceskahospodynka.mobile.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Article;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.ArticlesTask;

import cz.ceskahospodynka.mobile.ui.adapters.ArticleAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 22.4.14.
 */

@ContentView(R.layout.activity_articles)
public class ArticlesActivity extends ProcessActivity {

    public static final String EXTRA_ARTICLE_ID = "articleId";

    private static final String TAG = ArticlesActivity.class.getSimpleName();

    @InjectView(R.id.articles_view)
    private ListView articleView;

    private ArticleAdapter articleAdapter;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if(isOnline()) {
            loadArticles();
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    private void loadArticles() {

        new ArticlesTask().task(Article.class, new AfterExecutor() {
            @Override
            public void work(Object val) {

                if (val != null && val instanceof Article) {
                    articleAdapter = new ArticleAdapter(ArticlesActivity.this, ((Article)val).getArticleList());
                    articleView.setAdapter(articleAdapter);

                    articleView.setClickable(true);
                    articleView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                        @Override
                        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                            Bundle bundle = new Bundle();
                            bundle.putInt(EXTRA_ARTICLE_ID, ((Article.Item) articleAdapter.getItem(position)).getId());

                            Intent intent = new Intent(ArticlesActivity.this, ArticleDetailActivity.class);
                            intent.putExtras(bundle);
                            startActivity(intent);
                        }
                    });
                    setProcess(false);
                }
            }
        });
    }
}
