package cz.ceskahospodynka.mobile.ui;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.view.ViewPager;
import android.support.v7.app.ActionBar;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.ui.adapters.BestRecipeSectionAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 21.4.14.
 */
@ContentView(R.layout.activity_bests)
public class BestRecipesActivity extends ProcessActivity implements ActionBar.TabListener {

    public static final String SELECTED_TAB_INDEX = "tabIndex";

    @InjectView(R.id.bests_pager)
    private ViewPager mViewPager;

    private int lastSelectedTab = 0;
    private BestRecipeSectionAdapter bestRecipeSectionAdapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        Bundle bundle = getIntent().getExtras();
        if (bundle != null) {
            lastSelectedTab = bundle.getInt(SELECTED_TAB_INDEX);
        }

        bestRecipeSectionAdapter = new BestRecipeSectionAdapter(getSupportFragmentManager());
        final ActionBar actionBar = getSupportActionBar();
        actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);

        mViewPager.setAdapter(bestRecipeSectionAdapter);
        mViewPager.setOnPageChangeListener(new ViewPager.SimpleOnPageChangeListener() {
            @Override
            public void onPageSelected(int position) {
                actionBar.setSelectedNavigationItem(position);
            }
        });

        String tabTitle[] = new String[]{getResources().getString(R.string.bests_topwatch), getResources().getString(R.string.bests_bests),};

        for (int i = 0; i < bestRecipeSectionAdapter.getCount(); i++) {
            actionBar.addTab(
                    actionBar.newTab()
                            .setText(tabTitle[i])
                            .setTabListener(this)
            );
        }
        mViewPager.setCurrentItem(lastSelectedTab);

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putInt(SELECTED_TAB_INDEX,
                getSupportActionBar().getSelectedTab().getPosition());
    }

    @Override
    public void onTabSelected(ActionBar.Tab tab, FragmentTransaction ft) {
        mViewPager.setCurrentItem(tab.getPosition());
    }

    @Override
    public void onTabUnselected(ActionBar.Tab tab, FragmentTransaction ft) {

    }

    @Override
    public void onTabReselected(ActionBar.Tab tab, FragmentTransaction ft) {

    }
}
