package cz.ceskahospodynka.mobile.ui;

import android.content.ContentValues;
import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.util.Base64;

import cz.ceskahospodynka.mobile.core.beans.Category;
import cz.ceskahospodynka.mobile.core.database.hospodynka.Creator;
import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.CategoryModel;
import cz.ceskahospodynka.mobile.core.database.hospodynka.handlers.CategoryHandler;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.CategoriesTask;
import cz.ceskahospodynka.mobile.core.utils.AES;

/**
 * Created by tomas, Medoro s.r.o. on 20.4.15.
 */
public class CategoryHelper {

    private Context context;
    private boolean loadCategory = true;

    public CategoryHelper(Context context) {
        this.context = context;
    }

    public void syncCategory(final AfterExecutor afterExecutor){

        final Creator creator = new Creator(context);
        CategoryHandler categoryHandler = new CategoryHandler();

        int categoryCount = 0;
        SQLiteDatabase db = creator.getWritableConnection();
        try {
            categoryCount = categoryHandler.getCount(db);
        } finally {
            db.close();
        }

        if(categoryCount == 0){
            new CategoriesTask().task(Category.class, new AfterExecutor() {
                @Override
                public void work(Object val) {

                    if(val != null && val instanceof Category) {

                        SQLiteDatabase db = creator.getWritableConnection();
                        try{
                            CategoryHandler categoryHandler1 = new CategoryHandler();
                            db.delete(categoryHandler1.getGenerator().getTableName(), null, null);
                            for (Category.Item i : ((Category)val).getCategoryList()) {

                                byte[] decodedString = Base64.decode(i.getObrazekBase64(), Base64.DEFAULT);
                                ContentValues values = new ContentValues();
                                values.put(((CategoryModel) categoryHandler1.getModel()).getCategoryNameColumn() , AES.decrypt(i.getKategorie()));
                                values.put(((CategoryModel) categoryHandler1.getModel()).getCategoryImageColumn(), decodedString);
                                values.put(((CategoryModel) categoryHandler1.getModel()).getCategoryImageUrlColumn(), AES.decrypt(i.getObrazek()));
                                db.insert(categoryHandler1.getGenerator().getTableName(), null, values);

                            }
                        } finally {
                            db.close();
                        }
                    }
                    afterExecutor.work(null);
                }
            });
        }
        afterExecutor.work(null);
    }

}
