package cz.ceskahospodynka.mobile.ui;

import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas, Medoro s.r.o. on 6.5.15.
 */

@ContentView(R.layout.activity_help)
public class HelpActivity extends BaseActivity {

    @InjectView(R.id.version)
    TextView version;

    @InjectView(R.id.author)
    TextView author;

    @InjectView(R.id.libraries)
    TextView libraries;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        try {
            PackageInfo pInfo = getPackageManager().getPackageInfo(getPackageName(), 0);
            version.setText(getString(R.string.help_version, pInfo.versionName));
        } catch (PackageManager.NameNotFoundException e) {
            Log.w("HelpActivity", e);
        }

        author.setText(Html.fromHtml(getString(R.string.help_author)));

        libraries.setText(Html.fromHtml(getString(R.string.help_library)));

    }
}
