package cz.ceskahospodynka.mobile.ui;

import com.facebook.AccessToken;
import com.facebook.CallbackManager;
import com.facebook.FacebookCallback;
import com.facebook.FacebookException;
import com.facebook.FacebookSdk;
import com.facebook.Profile;
import com.facebook.appevents.AppEventsLogger;
import com.facebook.login.LoginManager;
import com.facebook.login.LoginResult;
import com.facebook.login.widget.LoginButton;
import com.google.android.gms.plus.model.people.Person;

import android.annotation.TargetApi;
import android.content.ContentValues;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.sqlite.SQLiteDatabase;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Uri;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.text.Html;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.Settings;
import cz.ceskahospodynka.mobile.core.beans.Article;
import cz.ceskahospodynka.mobile.core.beans.Link;
import cz.ceskahospodynka.mobile.core.beans.MyRecipe;
import cz.ceskahospodynka.mobile.core.beans.Opinion;
import cz.ceskahospodynka.mobile.core.beans.Recipe;
import cz.ceskahospodynka.mobile.core.beans.Title;
import cz.ceskahospodynka.mobile.core.beans.User;
import cz.ceskahospodynka.mobile.core.database.core.RS;
import cz.ceskahospodynka.mobile.core.database.core.TableModel;
import cz.ceskahospodynka.mobile.core.database.hospodynka.Creator;
import cz.ceskahospodynka.mobile.core.database.hospodynka.RecipeLoader;
import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.CategoryModel;
import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.RecipeModel;
import cz.ceskahospodynka.mobile.core.database.hospodynka.handlers.CategoryHandler;
import cz.ceskahospodynka.mobile.core.database.hospodynka.handlers.RecipeHandler;
import cz.ceskahospodynka.mobile.core.socialNetworks.Google;
import cz.ceskahospodynka.mobile.core.socialNetworks.GoogleOnLogin;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.LoginTask;
import cz.ceskahospodynka.mobile.core.tasks.SyncTask;
import cz.ceskahospodynka.mobile.core.tasks.TitleTask;
import cz.ceskahospodynka.mobile.core.utils.ActivitySwitcherListener;
import cz.ceskahospodynka.mobile.core.utils.CategoryStack;
import cz.ceskahospodynka.mobile.core.utils.IO;
import cz.ceskahospodynka.mobile.core.utils.ResizeAnimation;
import cz.ceskahospodynka.mobile.ui.adapters.CategoryAdapter;
import cz.ceskahospodynka.mobile.ui.adapters.CategoryGridItem;

import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.TimeoutException;

import cz.ceskahospodynka.mobile.ui.adapters.RecipeItem;
import cz.ceskahospodynka.mobile.ui.fragments.FavoriteFragment;
import roboguice.inject.ContentView;
import roboguice.inject.InjectView;
/**
 * Created by tomas, Medoro s.r.o. on 14.11.14.
 */

@ContentView(R.layout.activity_main)
public class HospodynkaActivity extends ProcessActivity {

    private static final int CATEGORY_HEIGHT = 170;
    private static final int CATEGORY_ITEM_HEIGHT = 140;

    private Google google = new Google();

    @InjectView(R.id.google_plus_button) private Button googleButton;
    @InjectView(R.id.facebook_button) private LoginButton facebookButton;

    @InjectView(R.id.favorite_link) TextView favoriteView;
    @InjectView(R.id.favorite_btn) Button favoriteBtn;

    @InjectView(R.id.news_link) TextView newsView;
    @InjectView(R.id.news_btn) Button newsBtn;

    @InjectView(R.id.bests_link) TextView bestsView;
    @InjectView(R.id.bests_btn) Button bestsBtn;

    @InjectView(R.id.topwatch_link) TextView topwatchView;
    @InjectView(R.id.topwatch_btn) Button topwatchBtn;

    @InjectView(R.id.opinions_link) TextView opinionView;
    @InjectView(R.id.opinions_btn) Button opinionBtn;

    @InjectView(R.id.menu_link) TextView menuView;
    @InjectView(R.id.menu_btn) Button menuBtn;

    @InjectView(R.id.link_link_link) TextView linkView;
    @InjectView(R.id.link_btn) Button linkBtn;

    @InjectView(R.id.article_link) TextView articleView;
    @InjectView(R.id.article_btn) Button articleBtn;

    private Integer opinionRecipeId;
    @InjectView(R.id.opinion_recipe) TextView opinionRecipe;
    @InjectView(R.id.opinion_author) TextView opinionAuthor;
    @InjectView(R.id.opinion_date) TextView opinionDate;
    @InjectView(R.id.opinion_text) TextView opinionText;

    private cz.ceskahospodynka.mobile.core.beans.Menu.Item menuItem;
    @InjectView(R.id.menu_name) TextView menuName;
    @InjectView(R.id.menu_title) TextView menuTitle;

    @InjectView(R.id.link_link) TextView linkLink;
    @InjectView(R.id.link_dsc) TextView linkDsc;

    private Integer articleId;
    @InjectView(R.id.article_header) TextView articleHeader;
    @InjectView(R.id.article_article) TextView articleArticle;

    @InjectView(R.id.login_user) TextView chLogin;
    @InjectView(R.id.login_password) TextView chPassword;
    @InjectView(R.id.login_btn) Button chBtn;

    Button moreCategories;

    private FavoriteFragment favoriteFragment;
    private CallbackManager callbackManager;

    private ExecutorService executorService = Executors.newCachedThreadPool();
    private SimpleDateFormat df;

    @Override
    protected void onCreate(Bundle savedInstanceState) {


        FacebookSdk.sdkInitialize(this.getApplicationContext());
        callbackManager = CallbackManager.Factory.create();

        LoginManager.getInstance().registerCallback(callbackManager,
                new FacebookCallback<LoginResult>() {
                    @Override
                    public void onSuccess(LoginResult loginResult) {
                        facebookUpdate();
                    }
                    @Override
                    public void onCancel() {
                        facebookUpdate();
                    }
                    @Override
                    public void onError(FacebookException exception) {
                        facebookUpdate();
                    }
                });

        super.onCreate(savedInstanceState);
        getSupportActionBar().setDisplayHomeAsUpEnabled(false);

        this.df = new SimpleDateFormat(getResources().getString(R.string.formatter_date_time));

        initGoogle(savedInstanceState);
        initFacebook();

        if(isOnline()) {
            initCategories(false);
            syncCategories();
            initAppPath();
        }

        initComponents();

        //IO.copyDbToSd(this);
    }

    private void initGoogle(Bundle savedInstanceState){
        google.onCreate(this, googleButton, savedInstanceState, new GoogleOnLogin() {
            @Override
            public void onLogin(final Person user) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        if(user != null) {
                            addString(PREF_GOOGLE_USER_UID, user.getId());
                            addString(PREF_GOOGLE_USER_NAME, user.getDisplayName());

                            googleButton.setText(user.getDisplayName());
                            googleButton.setEnabled(false);

                            sync();
                        }
                    }
                });
            }
        });
    }

    private void initFacebook(){
        facebookButton.setPadding(0, 20, 0, 20);
        facebookButton.setBackgroundColor(R.color.facebook);
        facebookButton.setCompoundDrawablesWithIntrinsicBounds(0, 0, 0, 0);
        facebookButton.setText(R.string.fb_login);
    }

    private void syncCategories(){
        CategoryHelper categoryHelper = new CategoryHelper(this);
        categoryHelper.syncCategory(new AfterExecutor() {
            @Override
            public void work(Object val) {
                Creator creator = new Creator(HospodynkaActivity.this);
                SQLiteDatabase db = creator.getWritableConnection();
                try {
                    final List<CategoryGridItem> categories = new LinkedList<CategoryGridItem>();

                    CategoryHandler categoryHandler = new CategoryHandler();
                    categoryHandler.fetch(db, new RS() {
                        @Override
                        public void fetch(TableModel model) {
                            categories.add(new CategoryGridItem(((CategoryModel)model).categoryName, ((CategoryModel)model).categoryImage));
                        }
                    });

                    categoryGrid.setAdapter(new CategoryAdapter(HospodynkaActivity.this, categories));
                    categoryGrid.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                        @Override
                        public void onItemClick(AdapterView<?> parent, View v, int position, long id) {
                            goRecipes(categories.get(position).getTitle());
                        }
                    });
                    setProcess(false);

                    if(detectDevice() == Device.PHONE) {
                        ViewGroup.LayoutParams layoutParams = categoryGrid.getLayoutParams();
                        layoutParams.height = CATEGORY_HEIGHT;
                        categoryGrid.setLayoutParams(layoutParams);
                    }
                } finally {
                    db.close();
                }
            }
        });
    }

    private void chLogin(){

       new LoginTask(chLogin.getText().toString(), chPassword.getText().toString()).task(User.class, new AfterExecutor() {
           @Override
           public void work(Object val) {
               if(val != null && val instanceof User){
                   User user = (User) val;

                   if(user.getUserId() != null){
                        addString(BaseActivity.PREF_CH_USERNAME, chLogin.getText().toString());
                   }

                   sync();
               }
           }
       });
    }

    private void initAppPath(){
        new TitleTask().task(Title.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if(val != null && val instanceof Title){
                    Title title = (Title) val;

                    opinionRecipeId = title.getOpinion().getId();
                    opinionRecipe.setText(title.getOpinion().getNazev());
                    opinionAuthor.setText(title.getOpinion().getPodpis());
                    opinionDate.setText(df.format(title.getOpinion().getDatum()));
                    opinionText.setText(title.getOpinion().getNazor().substring(0, title.getOpinion().getNazor().length() > 90 ? 90 : title.getOpinion().getNazor().length()) + " ...");

                    opinionRecipe.setOnClickListener(opinionListener);
                    opinionAuthor.setOnClickListener(opinionListener);
                    opinionAuthor.setOnClickListener(opinionListener);
                    opinionDate.setOnClickListener(opinionListener);
                    opinionText.setOnClickListener(opinionListener);

                    menuItem = title.getMenu();
                    menuName.setText(title.getMenu().getNazev());
                    menuTitle.setText(title.getMenu().getPopis());

                    menuTitle.setOnClickListener(menuListener);
                    menuName.setOnClickListener(menuListener);

                    articleId = title.getArticle().getId();
                    articleHeader.setText(title.getArticle().getNadpis());
                    articleArticle.setText(Html.fromHtml(title.getArticle().getFejeton()).toString().substring(0, 90) + " ...");

                    articleArticle.setOnClickListener(articleListener);
                    articleHeader.setOnClickListener(articleListener);

                    linkLink.setText(title.getLink().getUrl_odkazu());
                    linkDsc.setText(title.getLink().getPopis());

                    linkDsc.setOnClickListener(linkListener);
                    linkLink.setOnClickListener(linkListener);
                }
            }
        });
    }

    private void initComponents(){

        favoriteFragment = (FavoriteFragment)getSupportFragmentManager().findFragmentById(R.id.favorite_fragment);

        favoriteView.setOnClickListener(new ActivitySwitcherListener(this, MyRecipesActivity.class));
        favoriteBtn.setOnClickListener(new ActivitySwitcherListener(this, MyRecipesActivity.class));

        newsView.setOnClickListener(new ActivitySwitcherListener(this, NewsActivity.class));
        newsBtn.setOnClickListener(new ActivitySwitcherListener(this, NewsActivity.class));

        ActivitySwitcherListener bestSwitcher = new ActivitySwitcherListener(this, BestRecipesActivity.class){
            @Override
            public Intent setExtra(Intent intent) {
                intent.putExtra(BestRecipesActivity.SELECTED_TAB_INDEX, 1);
                return super.setExtra(intent);
            }
        };
        bestsView.setOnClickListener(bestSwitcher);
        bestsBtn.setOnClickListener(bestSwitcher);

        ActivitySwitcherListener topWatchSwitcher = new ActivitySwitcherListener(this, BestRecipesActivity.class){
            @Override
            public Intent setExtra(Intent intent) {
                intent.putExtra(BestRecipesActivity.SELECTED_TAB_INDEX, 0);
                return super.setExtra(intent);
            }
        };

        topwatchView.setOnClickListener(topWatchSwitcher);
        topwatchBtn.setOnClickListener(topWatchSwitcher);

        opinionView.setOnClickListener(new ActivitySwitcherListener(this, LastOpinionsActivity.class));
        opinionBtn.setOnClickListener(new ActivitySwitcherListener(this, LastOpinionsActivity.class));

        menuView.setOnClickListener(new ActivitySwitcherListener(this, MenusActivity.class));
        menuBtn.setOnClickListener(new ActivitySwitcherListener(this, MenusActivity.class));

        articleView.setOnClickListener(new ActivitySwitcherListener(this, ArticlesActivity.class));
        articleBtn.setOnClickListener(new ActivitySwitcherListener(this, ArticlesActivity.class));

        linkView.setOnClickListener(new ActivitySwitcherListener(this, LinkActivity.class));
        linkBtn.setOnClickListener(new ActivitySwitcherListener(this, LinkActivity.class));

        chBtn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                chLogin();
            }
        });

        if(detectDevice() == Device.PHONE) {
            moreCategories = (Button)findViewById(R.id.more_categories);
            moreCategories.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {

                    if(categoryGrid == null){
                        return;
                    }

                    ViewGroup.LayoutParams layoutParams = categoryGrid.getLayoutParams();
                    if (categoryGrid.getLayoutParams().height == CATEGORY_HEIGHT) {

                        int newHeight = ((int) Math.round(((float) categoryGrid.getAdapter().getCount() / getNumColumnsCompat()))) * CATEGORY_ITEM_HEIGHT;
                        categoryGrid.startAnimation(new ResizeAnimation(categoryGrid, layoutParams.width, layoutParams.height, layoutParams.width, newHeight));

                        //layoutParams.height = newHeight;



                        moreCategories.setText(R.string.main_less);

                    } else {
                        categoryGrid.startAnimation(new ResizeAnimation(categoryGrid, layoutParams.width, layoutParams.height, layoutParams.width, CATEGORY_HEIGHT));
                        //layoutParams.height = CATEGORY_HEIGHT;
                        moreCategories.setText(R.string.main_more);
                    }
                    categoryGrid.setLayoutParams(layoutParams);
                }
            });
        }

        if(getString(BaseActivity.PREF_CH_USERNAME) != null){
            chLogin.setText(getString(BaseActivity.PREF_CH_USERNAME));
        }

    }

    private int getNumColumnsCompat() {
        if (Build.VERSION.SDK_INT >= 11) {
            return getNumColumnsCompat11();

        } else {
            int columns = 0;
            int children = categoryGrid.getChildCount();
            if (children > 0) {
                int width = categoryGrid.getChildAt(0).getMeasuredWidth();
                if (width > 0) {
                    columns = categoryGrid.getWidth() / width;
                }
            }
            return columns > 0 ? columns : categoryGrid.AUTO_FIT;
        }
    }

    @TargetApi(Build.VERSION_CODES.HONEYCOMB)
    private int getNumColumnsCompat11() {
        return categoryGrid.getNumColumns();
    }

    private void facebookUpdate(){
        boolean enableButtons = AccessToken.getCurrentAccessToken() != null;

        Profile profile = Profile.getCurrentProfile();
        if (enableButtons && profile != null) {
            addString(PREF_FACEBOOK_USER_UID, profile.getId());
            addString(PREF_FACEBOOK_USER_NAME, profile.getName());
            facebookButton.setText(profile.getName());
            sync();
        }
    }

    private void sync(){

        final MyRecipe myRecipe = getMyRecipes();
        Log.d("TEST", "sync start");
        new SyncTask(getString(BaseActivity.PREF_FACEBOOK_USER_UID),
                getString(BaseActivity.PREF_GOOGLE_USER_UID),
                getString(BaseActivity.PREF_CH_USERNAME),
                getString(BaseActivity.PREF_CH_PASSWORD),
                gson.toJson(myRecipe)).task(Recipe.class, new AfterExecutor() {

            @Override
            public void work(Object val) {
                if(val != null && val instanceof Recipe){

                    Log.d("TEST", "sync end");

                    Recipe recipes = (Recipe) val;

                    final List<Future<?>> syncFutures = new LinkedList<Future<?>>();
                    for (final Recipe.Item recipe : recipes.getRecipeList()) {

                        if(!canContinue(recipe)){
                            continue;
                        }

                        RecipeItem recipeItem = RecipeLoader.decryptRecipe(recipe, true, Settings.IMAGE_ORIGINAL);
                        syncFutures.add(getSyncFuture(recipeItem));
                    }

                    for(Future<?> f : syncFutures) {
                        try {
                            f.get(55, TimeUnit.SECONDS);
                        } catch (InterruptedException e) {
                        } catch (ExecutionException e) {
                        } catch (TimeoutException e) {
                        }
                    }

                    favoriteFragment.initRecipes(HospodynkaActivity.this);
                    Toast.makeText(HospodynkaActivity.this, getResources().getString(R.string.sync_ok), Toast.LENGTH_SHORT).show();
                }
            }
        });
    }

    private MyRecipe getMyRecipes(){
        final MyRecipe myRecipe = new MyRecipe();
        Creator creator = new Creator(this);
        SQLiteDatabase db = creator.getWritableConnection();
        try {
            RecipeHandler recipeHandler = new RecipeHandler();
            recipeHandler.fetch(db, new RS() {
                @Override
                public void fetch(TableModel model) {
                    myRecipe.getRecipesId().add(((RecipeModel) model).recipeId);
                }
            }, true);
        } finally {
            db.close();
        }
        return myRecipe;
    }

    private boolean canContinue(Recipe.Item recipe){
        RecipeHandler recipeHandler = new RecipeHandler();
        Creator creator = new Creator(HospodynkaActivity.this);
        SQLiteDatabase db = creator.getWritableConnection();
        try {
            if (recipeHandler.isRecipe(db, recipe.getId())) {
                return false;
            }
        } finally {
            db.close();
        }
        return true;
    }

    private Future<?> getSyncFuture(final RecipeItem recipeItem){
        return executorService.submit(new Runnable() {
            @Override
            public void run() {
                try {
                    URL url = new URL(recipeItem.getRecipeImage());
                    Bitmap bitmap = BitmapFactory.decodeStream(url.openConnection().getInputStream());

                    RecipeHandler recipeHandler = new RecipeHandler();
                    Creator creator = new Creator(HospodynkaActivity.this);
                    SQLiteDatabase db = creator.getWritableConnection();
                    try {
                        ContentValues values = new ContentValues();
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeIdColumn(), recipeItem.getRecipeId());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeNameColumn(), recipeItem.getRecipeName());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeIngredientColumn(), recipeItem.getIngredient());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeAdvanceColumn(), recipeItem.getInstruction());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeMainIngredientColumn(), recipeItem.getMainIngredient());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipePointsColumn(), recipeItem.getPoints());
                        values.put(((RecipeModel) recipeHandler.getModel()).getRecipeImageUrlColumn(), recipeItem.getRecipeImage());

                        if (bitmap != null) {
                            values.put(((RecipeModel) recipeHandler.getModel()).getRecipeImageColumn(), IO.getBitmapAsByteArray(bitmap));
                        }
                        db.insert(recipeHandler.getGenerator().getTableName(), null, values);
                    } finally {
                        db.close();
                    }

                } catch (Exception e) {
                    Log.w("TEST", e);
                }
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();

        // aktualizace oblibenych
        if(favoriteFragment != null){
            favoriteFragment.initRecipes(this);
        }

        AppEventsLogger.activateApp(this);
        facebookUpdate();
    }

    private void goRecipes(String category) {
        Intent intent = new Intent(this, RecipesActivity.class);
        Bundle bundle = new Bundle();

        CategoryStack categoryStack = new CategoryStack(category);
        bundle.putString(RecipesCategoriesActivity.EXTRA_CATEGORY_INFO, gson.toJson(categoryStack));

        intent.putExtras(bundle);
        startActivity(intent);
    }

    View.OnClickListener opinionListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            Intent intent = new Intent(HospodynkaActivity.this, RecipeActivity.class);
            Bundle bundle = new Bundle();
            bundle.putInt(RecipesActivity.EXTRA_RECIPE_ID, opinionRecipeId);
            intent.putExtras(bundle);
            startActivity(intent);
        }
    };

    View.OnClickListener menuListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            Intent intent = new Intent(HospodynkaActivity.this, MenuDetailActivity.class);
            Bundle bundle = new Bundle();
            bundle.putString(MenusActivity.EXTRA_ITEM, gson.toJson(menuItem));
            intent.putExtras(bundle);
            startActivity(intent);
        }
    };

    View.OnClickListener articleListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            Bundle bundle = new Bundle();
            bundle.putInt(ArticlesActivity.EXTRA_ARTICLE_ID, articleId);

            Intent intent = new Intent(HospodynkaActivity.this, ArticleDetailActivity.class);
            intent.putExtras(bundle);
            startActivity(intent);
        }
    };

    View.OnClickListener linkListener = new View.OnClickListener() {
        @Override
        public void onClick(View v) {
            String link = linkLink.getText().toString();
            if (!link.startsWith("http://")) {
                link = "http://" + link;
            }

            Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(link));
            startActivity(intent);
        }
    };


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        if(!isOnline()){
            setProcess(false);
        }
        return true;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        finish();
    }

    @Override
    protected void onStart() {
        super.onStart();
        if(google.getmGoogleApiClient() != null)
            google.onStart();
    }

    @Override
    protected void onStop() {
        super.onStop();
        if(google.getmGoogleApiClient() != null)
            google.onStop();
    }

    @Override
    protected void onPause() {
        super.onPause();
        AppEventsLogger.deactivateApp(this);
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        if(google.getmGoogleApiClient() != null)
            google.onSaveInstanceState(outState);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        google.onActivityResult(requestCode, resultCode, data);
        callbackManager.onActivityResult(requestCode, resultCode, data);
    }
}
