package cz.ceskahospodynka.mobile.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Opinion;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.OpinionsTask;

import cz.ceskahospodynka.mobile.ui.adapters.OpinionsAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 16.4.14.
 */

@ContentView(R.layout.activity_last_opinions)
public class LastOpinionsActivity extends ProcessActivity {

    private static final String TAG = LastOpinionsActivity.class.getSimpleName();

    @InjectView(R.id.last_opinion_view)
    private ListView lastOpinionsView;

    private OpinionsAdapter lastOpinionAdapter;
    private Integer lastPosition;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        initView();

        if(isOnline()) {
            loadOpinions();
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    private void initView(){
        Bundle bundle = getIntent().getExtras();
        if (bundle != null) {
            lastPosition = bundle.getInt(RecipesActivity.EXTRA_RECIPE_POSITION);
        }

        lastOpinionsView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                Opinion.Item item = (Opinion.Item) parent.getItemAtPosition(position);
                Intent intent = new Intent(LastOpinionsActivity.this, RecipeActivity.class);
                Bundle bundle = new Bundle();
                bundle.putInt(RecipesActivity.EXTRA_RECIPE_ID, item.getId());
                intent.putExtras(bundle);
                startActivity(intent);

            }
        });
    }

    private void loadOpinions() {

        new OpinionsTask().task(Opinion.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if(val != null && val instanceof Opinion) {
                    lastOpinionAdapter = new OpinionsAdapter(LastOpinionsActivity.this, ((Opinion)val).getOpinionList(), R.layout.last_opinion_item);
                    lastOpinionsView.setAdapter(lastOpinionAdapter);

                    if (lastPosition != null) {
                        lastOpinionsView.setSelection(lastPosition);
                        lastPosition = null;
                    }
                }
                setProcess(false);
            }
        });
    }
}
