package cz.ceskahospodynka.mobile.ui;

import android.app.ListActivity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Link;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.LinkTask;

import cz.ceskahospodynka.mobile.ui.adapters.LinkAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 22.4.14.
 */

@ContentView(R.layout.activity_links)
public class LinkActivity extends ProcessActivity {

    private static final String TAG = ListActivity.class.getSimpleName();

    @InjectView(R.id.link_view)
    private ListView linkView;

    private LinkAdapter linkAdapter;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if(isOnline()) {
            loadLinks();
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    private void loadLinks() {

        new LinkTask().task(Link.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if(val != null && val instanceof Link){
                    linkAdapter = new LinkAdapter(LinkActivity.this, ((Link)val).getLinkList());
                    linkView.setAdapter(linkAdapter);

                    linkView.setClickable(true);
                    linkView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                        @Override
                        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

                            String link = ((Link.Item) linkAdapter.getItem(position)).getUrl_odkazu();
                            if (!link.startsWith("http://")) {
                                link = "http://" + link;
                            }

                            Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(link));
                            startActivity(intent);
                        }
                    });
                    setProcess(false);
                }
            }
        });
    }
}
