package cz.ceskahospodynka.mobile.ui;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ListView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Menu;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.MenuTask;

import cz.ceskahospodynka.mobile.ui.adapters.MenuAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 21.4.14.
 */

@ContentView(R.layout.activity_menus)
public class MenusActivity extends ProcessActivity {

    public static final String EXTRA_ITEM = "menuItem";

    private MenuAdapter menuAdapter;

    @InjectView(R.id.menu_view)
    private ListView menuView;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        if(isOnline()) {
            loadMenu();
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    private void loadMenu() {

        new MenuTask().task(Menu.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if(val != null && val instanceof Menu){
                    menuAdapter = new MenuAdapter(MenusActivity.this, ((Menu)val).getMenuList());
                    menuView.setAdapter(menuAdapter);
                    menuView.setClickable(true);
                    menuView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
                        @Override
                        public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
                            goToMenuDetail((Menu.Item) menuAdapter.getItem(position));
                        }
                    });
                    setProcess(false);
                }
            }
        });
    }

    private void goToMenuDetail(Menu.Item item) {
        Intent intent = new Intent(this, MenuDetailActivity.class);
        Bundle bundle = new Bundle();
        bundle.putString(EXTRA_ITEM, gson.toJson(item));
        intent.putExtras(bundle);
        startActivity(intent);
    }


}
