package cz.ceskahospodynka.mobile.ui;

import android.os.Bundle;
import android.support.v4.app.FragmentTransaction;
import android.support.v4.view.ViewPager;
import android.support.v7.app.ActionBar;
import android.view.Menu;
import android.widget.TextView;

import com.google.gson.Gson;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.ui.adapters.RecipeSectionAdapter;

import roboguice.inject.ContentView;
import roboguice.inject.InjectView;

/**
 * Created by tomas on 9.4.14.
 */

@ContentView(R.layout.activity_recipe)
public class RecipeActivity extends ProcessActivity implements ActionBar.TabListener {

    private static final byte TAB_OPINION = 1;

    private static final String SELECTED_TAB_INDEX = "tabIndex";


    @InjectView(R.id.pager)
    ViewPager mViewPager;

    private RecipeSectionAdapter mAppSectionsPagerAdapter;

    // oblibeny recept se natahne z databaze, nikoli z internetu
    private Integer recipeId;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        setShowNotConnectionInfo(false);
        super.onCreate(savedInstanceState);

        Bundle bundle = getIntent().getExtras();
        recipeId = bundle.getInt(RecipesActivity.EXTRA_RECIPE_ID);

        mAppSectionsPagerAdapter = new RecipeSectionAdapter(getSupportFragmentManager());
        final ActionBar actionBar = getSupportActionBar();
        actionBar.setNavigationMode(ActionBar.NAVIGATION_MODE_TABS);

        mViewPager.setAdapter(mAppSectionsPagerAdapter);
        mViewPager.setOnPageChangeListener(new ViewPager.SimpleOnPageChangeListener() {
            @Override
            public void onPageSelected(int position) {
                actionBar.setSelectedNavigationItem(position);
            }
        });


        for (int i = 0; i < mAppSectionsPagerAdapter.getCount(); i++) {
            actionBar.addTab(actionBar.newTab().setText(getTabTitles()[i]).setTabListener(this));
        }

        if(detectDevice() != Device.PHONE){
            initCategories(true);
        }
    }

    @Override
    protected void onSaveInstanceState(Bundle outState) {
        super.onSaveInstanceState(outState);
        outState.putInt(SELECTED_TAB_INDEX,
                getSupportActionBar().getSelectedTab().getPosition());
    }

    public Integer getRecipeId() {
        return recipeId;
    }

    public Gson getGson() {
        return gson;
    }

    @Override
    public void onTabSelected(ActionBar.Tab tab, FragmentTransaction ft) {
        mViewPager.setCurrentItem(tab.getPosition());
    }

    @Override
    public void onTabUnselected(ActionBar.Tab tab, FragmentTransaction ft) {

    }

    @Override
    public void onTabReselected(ActionBar.Tab tab, FragmentTransaction ft) {

    }

    public void renameOpinionTab(String opinionName){
        final ActionBar actionBar = getSupportActionBar();
        actionBar.removeAllTabs();

        String tabTitle[] = getTabTitles();
        tabTitle[TAB_OPINION] = opinionName;

        for (int i = 0; i < mAppSectionsPagerAdapter.getCount(); i++) {
            actionBar.addTab(actionBar.newTab().setText(tabTitle[i]).setTabListener(this));
        }
    }

    private String[] getTabTitles(){
        return new String[]{
                getResources().getString(R.string.recipe_tab_main),
                getResources().getString(R.string.recipe_tab_opinion),
                getResources().getString(R.string.recipe_save_opinion),
        };
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        setProcess(false);
        return true;
    }
}
