package cz.ceskahospodynka.mobile.ui.adapters;

import android.content.Context;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.core.beans.Article;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by tomas on 22.4.14.
 */
public class ArticleAdapter extends BaseAdapter {

    private LayoutInflater inflater;

    private List<Article.Item> data = new ArrayList<Article.Item>();
    private int layoutId;

    public ArticleAdapter(Context context, List<Article.Item> data) {
        this.data = data;
        this.inflater = LayoutInflater.from(context);
        this.layoutId = R.layout.articles_item;
    }

    @Override
    public int getCount() {
        return data.size();
    }

    @Override
    public Object getItem(int position) {
        return data.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ArticleHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(layoutId, null);

            holder = new ArticleHolder();
            holder.header = (TextView) convertView.findViewById(R.id.article_header);
            holder.article = (TextView) convertView.findViewById(R.id.article_article);

            convertView.setTag(holder);
        } else {
            holder = (ArticleHolder) convertView.getTag();
        }

        holder.header.setText(data.get(position).getNadpis());
        holder.article.setText(Html.fromHtml(data.get(position).getFejeton()));

        return convertView;
    }

    static class ArticleHolder {
        TextView header;
        TextView article;
    }

}
