package cz.ceskahospodynka.mobile.ui.adapters;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;

import java.util.ArrayList;
import java.util.List;


/**
 * Created by tomas on 16.3.14.
 */
public class CategoryAdapter extends BaseAdapter {

    private final Context context;
    private List<CategoryGridItem> images = new ArrayList<CategoryGridItem>();

    public CategoryAdapter(Context context, List<CategoryGridItem> images) {
        this.context = context;
        this.images = images;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        View row = convertView;
        RecordHolder holder = null;

        if (row == null) {
            LayoutInflater inflater = ((Activity) context).getLayoutInflater();
            row = inflater.inflate(R.layout.category_item, parent, false);

            holder = new RecordHolder();
            holder.categoryImage = (ImageView) row.findViewById(R.id.item_image);
            holder.categoryTitle = (TextView) row.findViewById(R.id.item_text);
            row.setTag(holder);
        } else {
            holder = (RecordHolder) row.getTag();
        }

        CategoryGridItem item = getItem(position);
        holder.categoryTitle.setText(item.getTitle());
        holder.categoryImage.setImageBitmap(getItem(position).getImage());

        return row;
    }

    @Override
    public int getCount() {
        return images.size();
    }

    @Override
    public CategoryGridItem getItem(int position) {
        return images.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    static class RecordHolder {
        ImageView categoryImage;
        TextView categoryTitle;
    }

}
