package cz.ceskahospodynka.mobile.ui.adapters;

import android.content.Context;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.squareup.picasso.Picasso;

import org.uhk.ceskahospodynka.mobile.R;

import java.util.ArrayList;
import java.util.List;

import cz.ceskahospodynka.mobile.core.beans.Article;
import cz.ceskahospodynka.mobile.ui.fragments.LastThreeHorizontalFragment;

/**
 * Created by tomas, Medoro s.r.o. on 6.5.15.
 */
public class HorizontalAdapter extends ArrayAdapter<LastThreeHorizontalFragment.Data> {

    private LayoutInflater inflater;

    private List<LastThreeHorizontalFragment.Data> data = new ArrayList<LastThreeHorizontalFragment.Data>();
    private int layoutId;

    private Context context;

    public HorizontalAdapter(Context context, List<LastThreeHorizontalFragment.Data> data) {
        super(context, R.layout.favorite_horizontal_fragment_item, data);
        this.context = context;
        this.data = data;
        this.inflater = LayoutInflater.from(context);
        this.layoutId = R.layout.favorite_horizontal_fragment_item;
    }

    /*@Override
    public int getCount() {
        return data.size();
    }

    @Override
    public LastThreeHorizontalFragment.Data getItem(int position) {
        return data.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }*/

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        ArticleHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(layoutId, null);

            holder = new ArticleHolder();
            holder.image = (ImageView) convertView.findViewById(R.id.favorite_image);
            holder.name = (TextView) convertView.findViewById(R.id.favorite_name);

            convertView.setTag(holder);
        } else {
            holder = (ArticleHolder) convertView.getTag();
        }

        holder.name.setText(data.get(position).getRecipeName());

        if(data.get(position).getImage() == null) {
            Picasso.with(context)
                    .load(data.get(position).getRecipeImageUrl())
                    .placeholder(R.drawable.ic_launcher_bw)
                    .error(R.drawable.ic_launcher)
                    .into(holder.image);
        } else {
            holder.image.setImageBitmap(data.get(position).getImage());
        }

        return convertView;
    }

    static class ArticleHolder {
        ImageView image;
        TextView name;
    }

}
