package cz.ceskahospodynka.mobile.ui.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.core.beans.Link;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by tomas on 22.4.14.
 */
public class LinkAdapter extends BaseAdapter {

    private LayoutInflater inflater;

    private List<Link.Item> data = new ArrayList<Link.Item>();
    private int layoutId;

    public LinkAdapter(Context context, List<Link.Item> data) {
        this.data = data;
        this.inflater = LayoutInflater.from(context);
        this.layoutId = R.layout.link_item;
    }

    @Override
    public int getCount() {
        return data.size();
    }

    @Override
    public Object getItem(int position) {
        return data.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {
        LinkHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(layoutId, null);

            holder = new LinkHolder();
            holder.link = (TextView) convertView.findViewById(R.id.link_link);
            holder.dsc = (TextView) convertView.findViewById(R.id.link_dsc);

            convertView.setTag(holder);
        } else {
            holder = (LinkHolder) convertView.getTag();
        }

        holder.link.setText(data.get(position).getUrl_odkazu());
        holder.dsc.setText(data.get(position).getPopis());

        return convertView;
    }

    static class LinkHolder {
        TextView link;
        TextView dsc;
    }

}
