package cz.ceskahospodynka.mobile.ui.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.core.beans.Menu;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by tomas on 21.4.14.
 */
public class MenuAdapter extends BaseAdapter {

    private LayoutInflater inflater;

    private List<Menu.Item> data = new ArrayList<Menu.Item>();
    private SimpleDateFormat df;
    private int layoutId;

    public MenuAdapter(Context context, List<Menu.Item> data) {
        this.data = data;
        this.inflater = LayoutInflater.from(context);
        this.df = new SimpleDateFormat(context.getResources().getString(R.string.formatter_date_time));
        this.layoutId = R.layout.menu_item;
    }

    @Override
    public int getCount() {
        return data.size();
    }

    @Override
    public Object getItem(int position) {
        return data.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {

        OpinionHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(layoutId, null);


            holder = new OpinionHolder();
            holder.menuName = (TextView) convertView.findViewById(R.id.menu_name);
            holder.menuTitle = (TextView) convertView.findViewById(R.id.menu_title);
            convertView.setTag(holder);
        } else {
            holder = (OpinionHolder) convertView.getTag();
        }

        holder.menuName.setText(data.get(position).getNazev());
        holder.menuTitle.setText(data.get(position).getPopis());
        return convertView;
    }

    static class OpinionHolder {
        TextView menuName;
        TextView menuTitle;
    }
}
