package cz.ceskahospodynka.mobile.ui.adapters;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import org.uhk.ceskahospodynka.mobile.R;
import cz.ceskahospodynka.mobile.core.beans.Opinion;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by tomas on 28.3.14.
 */
public class OpinionsAdapter extends BaseAdapter {

    private LayoutInflater inflater;

    private List<Opinion.Item> data = new ArrayList<Opinion.Item>();
    private SimpleDateFormat df;
    private int layoutId;

    public OpinionsAdapter(Context context, List<Opinion.Item> data) {
        this(context, data, R.layout.opinion_item);
    }

    public OpinionsAdapter(Context context, List<Opinion.Item> data, int layoutId) {
        this.data = data;
        this.inflater = LayoutInflater.from(context);
        this.df = new SimpleDateFormat(context.getResources().getString(R.string.formatter_date_time));
        this.layoutId = layoutId;
    }

    @Override
    public int getCount() {
        return data.size();
    }

    @Override
    public Object getItem(int position) {
        return data.get(position);
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @Override
    public View getView(final int position, View convertView, ViewGroup parent) {

        OpinionHolder holder;
        if (convertView == null) {
            convertView = inflater.inflate(layoutId, null);


            holder = new OpinionHolder();
            holder.opinion = (TextView) convertView.findViewById(R.id.opinion_text);
            holder.opinionUser = (TextView) convertView.findViewById(R.id.opinion_author);
            holder.opinionDate = (TextView) convertView.findViewById(R.id.opinion_date);

            if (layoutId == R.layout.last_opinion_item) {
                holder.recipeName = (TextView) convertView.findViewById(R.id.opinion_recipe);
            }

            convertView.setTag(holder);
        } else {
            holder = (OpinionHolder) convertView.getTag();
        }

        holder.opinion.setText(data.get(position).getNazor());
        holder.opinionUser.setText(data.get(position).getPodpis());
        holder.opinionDate.setText(df.format(data.get(position).getDatum()));
        if (layoutId == R.layout.last_opinion_item) {
            holder.recipeName.setText(data.get(position).getNazev());
        }
        return convertView;
    }

    static class OpinionHolder {
        TextView opinion;
        TextView opinionUser;
        TextView opinionDate;
        TextView recipeName;
    }

}
