package cz.ceskahospodynka.mobile.ui.adapters;

import android.graphics.Bitmap;

import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.RecipeModel;

/**
 * Created with IntelliJ IDEA.
 * User: tomas
 * Date: 15.11.13
 * Time: 23:01
 * To change this template use File | Settings | File Templates.
 */
public class RecipeItem implements Comparable<RecipeItem> {

    private String recipeImage;
    private Integer recipeId;
    private String recipeName;
    private String mainIngredient;

    private String ingredient;
    private String instruction;
    private String author;
    private String subCategory;

    private int points;
    private boolean favorite;

    private Bitmap bitmapImage;

    public RecipeItem(){

    }

    public RecipeItem(RecipeModel model){
        this(model.recipeId, model.recipeName, model.recipeMainIngredient, model.recipePoints, model.recipeImageUrl, true, model.recipeImage);
    }

    public RecipeItem(Integer recipeId, String recipeName, String mainIngredient, int points, String recipeImage, boolean favorite, Bitmap storageImage) {
        this(recipeId, recipeName, mainIngredient, points, recipeImage, storageImage, favorite, null, null, null, null);
    }

    public RecipeItem(Integer recipeId, String recipeName, String mainIngredient, int points, String recipeImage, Bitmap storageImage, boolean favorite, String ingredient, String instruction, String author, String subCategory) {
        this.recipeId = recipeId;
        this.recipeName = recipeName;
        this.mainIngredient = mainIngredient;
        this.points = points;
        this.recipeImage = recipeImage;
        this.favorite = favorite;
        this.ingredient = ingredient;
        this.instruction = instruction;
        this.author = author;
        this.subCategory = subCategory;
        this.bitmapImage = storageImage;
    }

    public Integer getRecipeId() {
        return recipeId;
    }

    public void setRecipeId(Integer recipeId) {
        this.recipeId = recipeId;
    }

    public String getRecipeName() {
        return recipeName;
    }

    public void setRecipeName(String recipeName) {
        this.recipeName = recipeName;
    }

    public String getMainIngredient() {
        return mainIngredient;
    }

    public void setMainIngredient(String mainIngredient) {
        this.mainIngredient = mainIngredient;
    }

    public int getPoints() {
        return points;
    }

    public void setPoints(int points) {
        this.points = points;
    }

    public void setRecipeImage(String recipeImage) {
        this.recipeImage = recipeImage;
    }

    public String getRecipeImage() {
        return recipeImage;
    }

    public void setFavorite(boolean favorite) {
        this.favorite = favorite;
    }

    public boolean isFavorite() {
        return this.favorite;
    }

    public String getIngredient() {
        return ingredient;
    }

    public void setIngredient(String ingredient) {
        this.ingredient = ingredient;
    }

    public String getInstruction() {
        return instruction;
    }

    public void setInstruction(String instruction) {
        this.instruction = instruction;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getSubCategory() {
        return subCategory;
    }

    public void setSubCategory(String subCategory) {
        this.subCategory = subCategory;
    }

    public Bitmap getBitmapImage() {
        return bitmapImage;
    }

    public void setBitmapImage(Bitmap bitmapImage) {
        this.bitmapImage = bitmapImage;
    }

    @Override
    public int compareTo(RecipeItem another) {
        return recipeName.compareTo(another.getRecipeName());
    }
}
