package cz.ceskahospodynka.mobile.ui.tabs;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ListView;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.beans.Opinion;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.OpinionsTask;

import cz.ceskahospodynka.mobile.ui.RecipeActivity;
import cz.ceskahospodynka.mobile.ui.adapters.OpinionsAdapter;

import roboguice.inject.InjectView;

/**
 * Created by tomas on 28.3.14.
 */

public class RecipeOpinionsTab extends RecipeTab {

    private static final String TAG = "RECIPE_OPINION";

    @InjectView(R.id.recipe_opinion_view)
    private ListView recipeOpinions;

    private OpinionsAdapter opinionsAdapter;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        super.onCreateView(inflater, container, savedInstanceState);
        View rootView = inflater.inflate(R.layout.recipe_opinions, container, false);
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
    }

    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        setProperties(getActivity());
        loadOpinionsFromUrl(getActivity());
    }

    private void loadOpinionsFromUrl(final Context context) {

        new OpinionsTask(recipeId).task(Opinion.class, new AfterExecutor() {
            @Override
            public void work(Object val) {
                if(val != null && val instanceof Opinion){
                    opinionsAdapter = new OpinionsAdapter(context, ((Opinion)val).getOpinionList());
                    recipeOpinions.setAdapter(opinionsAdapter);

                    if(context != null && context instanceof RecipeActivity){
                        ((RecipeActivity) context).renameOpinionTab(context.getString(R.string.recipe_tab_opinion_count, opinionsAdapter.getCount()));
                    }
                }
            }
        });
    }
}
