package cz.ceskahospodynka.mobile.ui.tabs;

import android.app.Activity;
import android.database.sqlite.SQLiteDatabase;
import android.os.Bundle;
import android.support.annotation.Nullable;
import android.text.Html;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.squareup.picasso.Picasso;

import org.uhk.ceskahospodynka.mobile.R;

import cz.ceskahospodynka.mobile.core.Settings;
import cz.ceskahospodynka.mobile.core.beans.DefaultApi;
import cz.ceskahospodynka.mobile.core.database.hospodynka.Creator;
import cz.ceskahospodynka.mobile.core.database.hospodynka.dao.RecipeModel;
import cz.ceskahospodynka.mobile.core.database.hospodynka.handlers.RecipeHandler;
import cz.ceskahospodynka.mobile.core.tasks.AfterExecutor;
import cz.ceskahospodynka.mobile.core.tasks.OpinionSaveTask;
import cz.ceskahospodynka.mobile.ui.BaseActivity;
import cz.ceskahospodynka.mobile.ui.ProcessActivity;
import cz.ceskahospodynka.mobile.ui.RecipeActivity;
import roboguice.inject.InjectView;

/**
 * Created by tomas, Medoro s.r.o. on 16.6.15.
 */
public class RecipeSaveOpinionTab extends RecipeTab {

    @InjectView(R.id.signature)
    EditText signature;

    @InjectView(R.id.opinion)
    EditText opinion;

    @InjectView(R.id.save_opinion)
    Button saveOpinion;

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.recipe_save_opinion, container, false);
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
    }

    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        final Activity activity = getActivity();

        setProperties(activity);
        String userName = "";
        if(((BaseActivity) activity).getString(BaseActivity.PREF_CH_USERNAME) != null){
            userName = ((BaseActivity) activity).getString(BaseActivity.PREF_CH_USERNAME);
        } else if(((BaseActivity) activity).getString(BaseActivity.PREF_FACEBOOK_USER_UID) != null){
            userName = ((BaseActivity) activity).getString(BaseActivity.PREF_FACEBOOK_USER_NAME);
        } else if(((BaseActivity) activity).getString(BaseActivity.PREF_GOOGLE_USER_UID) != null){
            userName = ((BaseActivity) activity).getString(BaseActivity.PREF_GOOGLE_USER_NAME);
        }

        signature.setText(userName);

        saveOpinion.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                if(signature.getText() == null || signature.getText().length() == 0){
                    Toast.makeText(activity, getResources().getString(R.string.recipe_save_opinion_not_saved_signature), Toast.LENGTH_SHORT).show();
                    return;
                }

                if(opinion.getText() == null || opinion.getText().length() == 0){
                    Toast.makeText(activity, getResources().getString(R.string.recipe_save_opinion_not_saved_opinion), Toast.LENGTH_SHORT).show();
                    return;
                }

                new OpinionSaveTask(opinion.getText().toString(), signature.getText().toString(), recipeId){

                    @Override
                    public void beforeTask() {
                        super.beforeTask();

                        if(activity instanceof ProcessActivity){
                            ((ProcessActivity)activity).setProcess(true);
                        }

                    }
                }.task(DefaultApi.class, new AfterExecutor() {
                    @Override
                    public void work(Object val) {
                        if(val != null && val instanceof DefaultApi){
                            if(((DefaultApi) val).getErr() == null || ((DefaultApi) val).getErr() == ""){
                                ((ProcessActivity)activity).setProcess(false);
                                Toast.makeText(activity, getResources().getString(R.string.recipe_save_opinion_saved), Toast.LENGTH_SHORT).show();

                                activity.finish();
                                startActivity(activity.getIntent());

                            }
                        }
                    }
                });
            }
        });

    }
}
