package cz.ceskahospodynka.api.controller;

import com.google.gson.Gson;

import cz.ceskahospodynka.api.mybatis.Mapper;
import cz.ceskahospodynka.api.pojo.Recipe;
import cz.ceskahospodynka.api.utility.AES;
import cz.ceskahospodynka.api.utility.ImageUtils.ImageSize;

public abstract class BaseApi {

	protected Mapper mapper;

	protected Gson gson = new Gson();
	
	public BaseApi(Mapper mapper) {
		this.mapper = mapper;
	}
	
	protected ImageSize getSize(String type){
		ImageSize size = ImageSize.SMALL;
		
		if(BaseController.IMAGE_SMALL.equals(type)){
			size = ImageSize.SMALL;
		} else if(BaseController.IMAGE_MEDIUM.equals(type)){
			size = ImageSize.MEDIUM;
		} else if(BaseController.IMAGE_ORIGINAL.equals(type)){
			size = ImageSize.ORIGINAL;
		}
		
		return size;
	}
	
	protected Recipe cryptRecipe(Recipe recipe){
		Recipe cryptRecipe = new Recipe();
		
		cryptRecipe.setId(recipe.getId());
		cryptRecipe.setBody(recipe.getBody());
		cryptRecipe.setHlavs(AES.encrypt(recipe.getHlavs()));
		cryptRecipe.setKategorie(AES.encrypt(recipe.getKategorie()));
		cryptRecipe.setNazev(AES.encrypt(recipe.getNazev()));
		cryptRecipe.setSuroviny(AES.encrypt(recipe.getSuroviny()));
		cryptRecipe.setPostup(AES.encrypt(recipe.getPostup()));
		cryptRecipe.setAutor(AES.encrypt(recipe.getAutor()));
		cryptRecipe.setPod_kategorie(AES.encrypt(recipe.getPod_kategorie()));
		cryptRecipe.setOpinions(recipe.getOpinions());
		return cryptRecipe;
	}
}
