package cz.ceskahospodynka.api.controller;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "/opinion", method = RequestMethod.POST, produces = "text/plain;charset=UTF-8")
public class OpinionController extends BaseController  {

	@RequestMapping("/get")
	@ResponseBody
	public String getRecipe(
			@RequestParam("api") String api,
			@RequestParam("id") Integer recipeId) {

		return getApi(api).getRecipeOpinions(recipeId);
	}
	
	@RequestMapping("/latest")
	@ResponseBody
	public String getLatest(@RequestParam("api") String api) {
		return getApi(api).getLatestOpinions();
	}
	
	@RequestMapping("/save")
	@ResponseBody
	public String save(
			@RequestParam("api") String api,
			@RequestParam("opinion") String opinion,
			@RequestParam("signature") String signature,
			@RequestParam("recipe") Integer recipe) {
		return getApi(api).saveOpinion(recipe, signature, opinion);
	}
}
