package cz.ceskahospodynka.api.controller;

import org.springframework.stereotype.Controller;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping(value = "/user", method = RequestMethod.POST, produces = "text/plain;charset=UTF-8")
public class UserController extends BaseController {
	
	@RequestMapping("/login")
	@ResponseBody
	public String login(ModelMap model, 
			@RequestParam("api") String api,
			@RequestParam("user") String user, 
			@RequestParam("password") String password
			) {
		return getApi(api).login(user, password);
	}
	
	@RequestMapping("/sync")
	@ResponseBody
	public String userSync(ModelMap model, 
			@RequestParam("api") String api,
			@RequestParam("user") String user, 
			@RequestParam("password") String password,
			@RequestParam("facebook") String facebookId,
			@RequestParam("google") String googleId,
			@RequestParam("recipes") String recipes
			) {
		
		return getApi(api).userSync(facebookId, googleId, user, password, recipes);
	}
}
