package cz.ceskahospodynka.api.utility.gzip;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GZIPFilter implements Filter {

	@Override
	public void destroy() {
	}

	@Override
	public void doFilter(ServletRequest servletrequest, ServletResponse servletresponse, FilterChain filterchain) throws IOException, ServletException {
		if (servletrequest instanceof HttpServletRequest) {
			HttpServletRequest httpservletrequest = (HttpServletRequest) servletrequest;
			HttpServletResponse httpservletresponse = (HttpServletResponse) servletresponse;
			String s = httpservletrequest.getHeader("accept-encoding");
			if (s != null && s.indexOf("gzip") != -1) {
				//System.out.println("GZIP supported, compressing.");
				GZIPResponseWrapper gzipresponsewrapper = new GZIPResponseWrapper(
						httpservletresponse);
				filterchain.doFilter(servletrequest, gzipresponsewrapper);
				gzipresponsewrapper.finishResponse();
				return;
			}
			filterchain.doFilter(servletrequest, servletresponse);
		}
	}

	@Override
	public void init(FilterConfig arg0) throws ServletException {
	}
}
