package cz.ceskahospodynka.api.version;

import java.io.IOException;

import org.springframework.http.ResponseEntity;

public interface Api {

	public static String VERSION_1 = "version1";
	
	public String getTitle();
	
	public String getArticles();
	
	public String getArticle(Integer id);
	
	public String getCategories();
	
	public String getCategoriesHash();
	
	public String getLinks();
	
	public String getMenus();
	
	public String getLatestOpinions();
	
	public String getRecipeOpinions(Integer recipeId);
	
	public String getRecipes(String category, Integer start, Integer limit, String order);
	
	public String searchRecipes(String searchString, Integer start, Integer limit);
	
	public String getRecipe(Integer recipeId);
	
	public String getNewRecipes(Integer limit);
	
	public String getTopwatchRecipe(Integer limit);
	
	public String getBestRecipes(Integer limit);
	
	public String saveFavoriteRecipe(String user, Integer recipe);
	
	public String dropFavoriteRecipe(String user, Integer recipe);
	
	public String savePoint(Integer recipe);
	
	public String saveOpinion(Integer recipe, String signature, String opinion);
	
	public String login(String user, String password);
	
	public String userSync(String facebookId, String googleId, String user, String password, String recipes);
	
	public ResponseEntity<byte[]> getRecipeImage(String type, Integer id) throws IOException ;
}
